<?php

	/*
	* Note: Spin Rewriter API server is using a 120-second timeout.
	* Client scripts should use a 150-second timeout to allow for HTTP connection overhead.
	*/
	set_time_limit(150);

	$data = array();
	
	// Spin Rewriter API settings - authentication:
	$data['email_address'] = "test@example.com";				// your Spin Rewriter email address goes here
	$data['api_key'] = "1ab234c#d5e67fg_h8ijklm?901n234";		// your unique Spin Rewriter API key goes here
	
	// Spin Rewriter API settings - request details:
	$data['action'] = "unique_variation_from_spintax";			// possible values: 'api_quota', 'text_with_spintax', 'unique_variation', 'unique_variation_from_spintax'
	$data['text'] = "John {will|will certainly} {book|make a reservation for} a {room|hotel suite}.";	// text with existing spintax
	$data['use_only_synonyms'] = "false";						// possible values: 'false' (default value), 'true'
	$data['reorder_paragraphs'] = "false";						// possible values: 'false' (default value), 'true'
	$data['add_html_markup'] = "false";                         // possible values: 'false' (default value), 'true'
	$data['use_html_linebreaks'] = "false";                     // possible values: 'false' (default value), 'true'
	



	
	// Don't change anything below this comment.
	
	// Make the actual API request and save the JSON response.
	$api_response = spinrewriter_api_post($data);
	
	// Output raw JSON response (as a string).
	echo "<b>Raw JSON response:</b>";
	echo "<br><br>\n\n";
	print_r($api_response);
	echo "<br><br><br><br>\n\n\n\n";

	// Output interpreted JSON response (as a native PHP array).
	$api_response_interpreted = json_decode($api_response, true);
	echo "<b>Interpreted JSON response:</b>";
	echo "<br><br>\n\n";
	echo "<pre>";
	print_r($api_response_interpreted);
	echo "</pre>";
	echo "<br><br><br><br>\n\n\n\n";
	
	/*
	 * Example of interpreted JSON response (success):
	 * Array
	 * (
     *  	[status] => OK
     *  	[response] => John will certainly make a reservation for a hotel suite.
     *  	[api_requests_made] => 7
     *  	[api_requests_available] => 43
	 * )
	 * 
	 * Example of interpreted JSON response (error):
	 * Array
	 * (
     *  	[status] => ERROR
     *  	[response] => API quota exceeded. You can make 100 requests per day.
	 * )
	 */
	
	
	
	/**
	 * Sends a request to the Spin Rewriter API and returns unformatted response
	 * @param $data
	 * @return string
	 */
	function spinrewriter_api_post($data){
		$data_raw = "";
		foreach ($data as $key => $value){
			$data_raw = $data_raw . $key . "=" . urlencode($value) . "&";
		}

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, "http://www.spinrewriter.com/action/api");
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data_raw);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$response = trim(curl_exec($ch));
		curl_close($ch);
		return $response;
	}
